<?php
# write by xenonserge

# deactivate http headers
$no_http_headers = true;
# include some cacti files for ease of use
include(dirname(__FILE__) . "/../include/config.php");
include(dirname(__FILE__) . "/../lib/snmp.php");

# define all OIDs we need for further processing
$oids = array(
        "index"         => ".1.3.6.1.2.1.2.2.1.1",
        "ifstatus"      => ".1.3.6.1.2.1.2.2.1.8",
        "ifdescription" => ".1.3.6.1.2.1.2.2.1.2",
        "ifname"        => ".1.3.6.1.2.1.31.1.1.1.1",
        "iftype"        => ".1.3.6.1.2.1.2.2.1.3",
        "ifspeed"       => ".1.3.6.1.2.1.2.2.1.5",
        "ifHWaddress"   => ".1.3.6.1.2.1.2.2.1.6",
        "ifInOctets"    => ".1.3.6.1.2.1.2.2.1.10",
        "ifOutOctets"   => ".1.3.6.1.2.1.2.2.1.16",
        "ifHCInOctets"  => ".1.3.6.1.2.1.31.1.1.1.6",
        "ifHCOutOctets" => ".1.3.6.1.2.1.31.1.1.1.10",
        "ifInDiscards"  => ".1.3.6.1.2.1.2.2.1.13",
        "ifOutDiscards" => ".1.3.6.1.2.1.2.2.1.19",
        "ifInNUcastPkts" => ".1.3.6.1.2.1.2.2.1.12",
        "ifOutNUcastPkts" => ".1.3.6.1.2.1.2.2.1.18",
        "ifInUcastPkts" => ".1.3.6.1.2.1.2.2.1.11",
        "ifOutUcastPkts" => ".1.3.6.1.2.1.2.2.1.17",
        "ifInErrors"    => ".1.3.6.1.2.1.2.2.1.14",
        "ifOutErrors"   => ".1.3.6.1.2.1.2.2.1.20",
        "ifModule"      => ".1.3.6.1.2.1.31.1.1.1.1",
        "ifPort"        => ".1.3.6.1.2.1.31.1.1.1.1",
        "ifPortName"    => ".1.3.6.1.2.1.31.1.1.1.1",
        );
$xml_delimiter          =  "!";

# all required input parms
$hostname       = $_SERVER["argv"][1];
$snmp_community = $_SERVER["argv"][2];
$snmp_version   = $_SERVER["argv"][3];
$snmp_port      = $_SERVER["argv"][4];
$snmp_timeout   = $_SERVER["argv"][5];
$snmp_user      = $_SERVER["argv"][6];
$snmp_pw        = $_SERVER["argv"][7];
$cmd            = $_SERVER["argv"][8];
if (isset($_SERVER["argv"][9]))  { $query_field = $_SERVER["argv"][9]; };
if (isset($_SERVER["argv"][10])) { $query_index = $_SERVER["argv"][10]; };

# get number of snmp retries from global settings
$snmp_retries   = read_config_option("snmp_retries");



# -------------------------------------------------------------------------
# script MUST respond to index queries
#       the command for this is defined within the XML file as
#       <arg_index>index</arg_index>
#       you may replace the string "index" both in the XML and here
# -------------------------------------------------------------------------
#       php -q <script> <parms> index
# will list all indices of the target values
# e.g. in case of interfaces
#      it has to respond with the list of interface indices
# -------------------------------------------------------------------------

if ($cmd == "index") {
        # retrieve all indices from target
        $return_arr = reindex(cacti_snmp_walk($hostname, "$snmp_community", $oids["index"],
                                              $snmp_version, $snmp_user, $snmp_pw, $snmp_port,
                                              $snmp_timeout, $snmp_retries));

        # and print each index as a separate line
        for ($i=0;($i<sizeof($return_arr));$i++) {
                print $return_arr[$i] . "\n";
        }



#
# -------------------------------------------------------------------------
# script MUST respond to query requests
#       the command for this is defined within the XML file as
#       <arg_query>query</arg_query>
#       you may replace the string "query" both in the XML and here
# -------------------------------------------------------------------------
#       php -q <script> <parms> query <function>
# where <function> is a parameter that tells this script,
# which target value should be retrieved
# e.g. in case of interfaces, <function> = ifdescription
#      it has to respond with the list of
#      interface indices along with the description of the interface
# -------------------------------------------------------------------------
}elseif ($cmd == "query") {
        $arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"],
                                             $snmp_version, $snmp_user, $snmp_pw, $snmp_port,
					     $snmp_timeout, $snmp_retries));
        $arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids[$query_field],
					 $snmp_version, $snmp_user, $snmp_pw, $snmp_port,
					 $snmp_timeout, $snmp_retries));

	#---------------------------------------si $query_field == module
	if ($query_field == "ifModule") {
	for ($i=0;($i<sizeof($arr_index));$i++) {

	$module = explode("/",$arr[$i]);
	if (!is_numeric($module[0])) { $module[0] = ""; }
	
                print $arr_index[$i] . $xml_delimiter . $module[0] . "\n";
	}
	}



        #______________________________________si $query_field == port
         elseif ($query_field == "ifPort" ) {


                for ($i=0;($i<sizeof($arr_index));$i++) {

                $module = explode("/",$arr[$i]);
                if (!is_numeric($module[0])) { $module[0] = ""; }
                if (!isset($module[1])) { $module[1] = ""; }

                print $arr_index[$i] . $xml_delimiter . $module[1] . "\n";

                }
         }




	#______________________________________si $query_field == ifPortName
	 elseif ($query_field == "ifPortName" ) {

		
	        for ($i=0;($i<sizeof($arr_index));$i++) {

	        $module = explode("/",$arr[$i]);
	        if (!is_numeric($module[0])) { $module[0] = ""; }
		if (!isset($module[1])) { $module[1] = ""; }
		$OID_portname = ".1.3.6.1.4.1.9.5.1.4.1.1.4.".$module[0].".$module[1]";
		$portname = cacti_snmp_get($hostname, $snmp_community, $OID_portname, $snmp_version, $snmp_user, $snmp_pw,
                              $snmp_port, $snmp_timeout, $snmp_retries);

        print $arr_index[$i] . $xml_delimiter . $portname . "\n";


	        }
	 }



	else {
	
        for ($i=0;($i<sizeof($arr_index));$i++) {
                print $arr_index[$i] . $xml_delimiter . $arr[$i] . "\n";
        }
	}
# 
# -------------------------------------------------------------------------
# script MUST respond to get requests
#       the command for this is defined within the XML file as
#       <arg_get>get</arg_get>
#       you may replace the string "get" both in the XML and here
# -------------------------------------------------------------------------
#       php -q <script> <parms> get <function> <index>
# where <function> is a parameter that tells this script,
# which target value should be retrieved
# and   <index>    is the index that should be queried
# e.g. in case of interfaces, <function> = ifdescription
#                             <index>    = 1
#      it has to respond with
#      the description of the interface for interface #1
# -------------------------------------------------------------------------
}elseif ($cmd == "get") {
        print (cacti_snmp_get($hostname, $snmp_community, $oids[$query_field] .
                              ".$query_index", $snmp_version, $snmp_user, $snmp_pw,
                              $snmp_port, $snmp_timeout, $snmp_retries));

# -------------------------------------------------------------------------
# -------------------------------------------------------------------------
} else {
        print "Invalid use of script query, required parameters:\n\n";
        print "    <hostname> <community> <version> <snmp_port> <timeout> <user> <pw> <cmd>\n";

}


function reindex($arr) {
        $return_arr = array();

        for ($i=0;($i<sizeof($arr));$i++) {
                $return_arr[$i] = $arr[$i]["value"];
        }

        return $return_arr;
}

?>
